/*------------------------------------------------------------------*/
/*    Copyright (C) Siemens AG (1999). All Rights Reserved          */
/*    Product:          SIMATIC PDM                                 */
/*                                                                  */
/*    Device:           P&F LB/FB-REMOTE IO                         */
/*    Description:      INCLUDE P&F BUS COUPLER CONFIG STRING       */
/*                                                                  */
/*    Dictionary:       PFDP_DC_V6.dct                              */
/*                                                                  */
/*  $Revision:   1.5  $                                             */
/*  $Date:   22 Mar 2000 16:31:06  $                                */
/*------------------------------------------------------------------*/


MENU    Page_ConfigString
{
    LABEL   [menu_config_string];
    ITEMS
    {
        Group_Master_Config,
        Group_Slave_Config,
        method_check_config_string
    }
}

MENU    Group_Master_Config
{
    LABEL   [menu_master_config];
    ITEMS
    {
        P0_BK_Master_Config_Len     (HIDDEN),
        P0_BK_Master_Config_1       (HIDDEN),
        P0_BK_Master_Config_2       (HIDDEN),
        P0_BK_Master_Config_3       (HIDDEN),
        P0_BK_Master_Config_4       (HIDDEN),
        P0_BK_Master_Config_5       (HIDDEN),
        P0_BK_Master_Config_6       (HIDDEN),
        P0_BK_Master_Config_7       (HIDDEN),
        P0_BK_Master_Config_8       (HIDDEN),
        P0_BK_Master_Config_9       (HIDDEN),
        P0_BK_Master_Config_10      (HIDDEN),
        P0_BK_Master_Config_11      (HIDDEN),
        P0_BK_Master_Config_12      (HIDDEN),
        P0_BK_Master_Config_13      (HIDDEN),
        P0_BK_Master_Config_14      (HIDDEN),
        P0_BK_Master_Config_15      (HIDDEN),
        P0_BK_Master_Config_16      (HIDDEN),
        P0_BK_Master_Config_17      (HIDDEN),
        P0_BK_Master_Config_18      (HIDDEN),
        P0_BK_Master_Config_19      (HIDDEN),
        P0_BK_Master_Config_20      (HIDDEN),
        P0_BK_Master_Config_21      (HIDDEN),
        P0_BK_Master_Config_22      (HIDDEN),
        P0_BK_Master_Config_23      (HIDDEN),
        P0_BK_Master_Config_24      (HIDDEN),
        P0_BK_Master_Config_25      (HIDDEN),
        P0_BK_Master_Config_26      (HIDDEN),
        P0_BK_Master_Config_27      (HIDDEN),
        P0_BK_Master_Config_28      (HIDDEN),
        P0_BK_Master_Config_29      (HIDDEN),
        P0_BK_Master_Config_30      (HIDDEN),
        P0_BK_Master_Config_31      (HIDDEN),
        P0_BK_Master_Config_32      (HIDDEN),
        P0_BK_Master_Config_33      (HIDDEN),
        P0_BK_Master_Config_34      (HIDDEN),
        P0_BK_Master_Config_35      (HIDDEN),
        P0_BK_Master_Config_36      (HIDDEN),
        P0_BK_Master_Config_37      (HIDDEN),
        P0_BK_Master_Config_38      (HIDDEN),
        P0_BK_Master_Config_39      (HIDDEN),
        P0_BK_Master_Config_40      (HIDDEN),
        P0_BK_Master_Config_41      (HIDDEN),
        P0_BK_Master_Config_42      (HIDDEN),
        P0_BK_Master_Config_43      (HIDDEN),
        P0_BK_Master_Config_44      (HIDDEN),
        P0_BK_Master_Config_45      (HIDDEN),
        P0_BK_Master_Config_46      (HIDDEN),
        P0_BK_Master_Config_47      (HIDDEN),
        P0_BK_Master_Config_48      (HIDDEN),
        P0_BK_Master_Config_49      (HIDDEN),
        P0_BK_Master_Config_50      (HIDDEN),
        Loc_Master_Config_1,
        Loc_Master_Config_2,
        Loc_Master_Config_3,
        Loc_Master_Config_4 
    }
}

MENU    Group_Slave_Config
{
    LABEL   [menu_slave_config];
    ITEMS
    {
        P0_BK_Slave_Config_Len      (HIDDEN),
        P0_BK_Slave_Config_1        (HIDDEN),
        P0_BK_Slave_Config_2        (HIDDEN),
        P0_BK_Slave_Config_3        (HIDDEN),
        P0_BK_Slave_Config_4        (HIDDEN),
        P0_BK_Slave_Config_5        (HIDDEN),
        P0_BK_Slave_Config_6        (HIDDEN),
        P0_BK_Slave_Config_7        (HIDDEN),
        P0_BK_Slave_Config_8        (HIDDEN),
        P0_BK_Slave_Config_9        (HIDDEN),
        P0_BK_Slave_Config_10       (HIDDEN),
        P0_BK_Slave_Config_11       (HIDDEN),
        P0_BK_Slave_Config_12       (HIDDEN),
        P0_BK_Slave_Config_13       (HIDDEN),
        P0_BK_Slave_Config_14       (HIDDEN),
        P0_BK_Slave_Config_15       (HIDDEN),
        P0_BK_Slave_Config_16       (HIDDEN),
        P0_BK_Slave_Config_17       (HIDDEN),
        P0_BK_Slave_Config_18       (HIDDEN),
        P0_BK_Slave_Config_19       (HIDDEN),
        P0_BK_Slave_Config_20       (HIDDEN),
        P0_BK_Slave_Config_21       (HIDDEN),
        P0_BK_Slave_Config_22       (HIDDEN),
        P0_BK_Slave_Config_23       (HIDDEN),
        P0_BK_Slave_Config_24       (HIDDEN),
        P0_BK_Slave_Config_25       (HIDDEN),
        P0_BK_Slave_Config_26       (HIDDEN),
        P0_BK_Slave_Config_27       (HIDDEN),
        P0_BK_Slave_Config_28       (HIDDEN),
        P0_BK_Slave_Config_29       (HIDDEN),
        P0_BK_Slave_Config_30       (HIDDEN),
        P0_BK_Slave_Config_31       (HIDDEN),
        P0_BK_Slave_Config_32       (HIDDEN),
        P0_BK_Slave_Config_33       (HIDDEN),
        P0_BK_Slave_Config_34       (HIDDEN),
        P0_BK_Slave_Config_35       (HIDDEN),
        P0_BK_Slave_Config_36       (HIDDEN),
        P0_BK_Slave_Config_37       (HIDDEN),
        P0_BK_Slave_Config_38       (HIDDEN),
        P0_BK_Slave_Config_39       (HIDDEN),
        P0_BK_Slave_Config_40       (HIDDEN),
        P0_BK_Slave_Config_41       (HIDDEN),
        P0_BK_Slave_Config_42       (HIDDEN),
        P0_BK_Slave_Config_43       (HIDDEN),
        P0_BK_Slave_Config_44       (HIDDEN),
        P0_BK_Slave_Config_45       (HIDDEN),
        P0_BK_Slave_Config_46       (HIDDEN),
        P0_BK_Slave_Config_47       (HIDDEN),
        P0_BK_Slave_Config_48       (HIDDEN),
        P0_BK_Slave_Config_49       (HIDDEN),
        P0_BK_Slave_Config_50       (HIDDEN),
        Loc_Slave_Config_1,
        Loc_Slave_Config_2,
        Loc_Slave_Config_3,
        Loc_Slave_Config_4
    }
}


/*******************************************************************************/
/*****  MASTER Configuration String  *******************************************/
/*******************************************************************************/

VARIABLE    P0_BK_Master_Config_Len
{
    LABEL       [menu_master_config];
    TYPE        UNSIGNED_INTEGER(1);
    CLASS       CONTAINED;
    HANDLING    READ;
}

VARIABLE    P0_BK_Master_Config_1
{
    LABEL       [menu_master_config];
    TYPE        UNSIGNED_INTEGER(1);
    CLASS       CONTAINED;
    HANDLING    READ;
}

P0_BK_Master_Config_2   LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_3   LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_4   LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_5   LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_6   LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_7   LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_8   LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_9   LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_10  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_11  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_12  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_13  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_14  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_15  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_16  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_17  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_18  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_19  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_20  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_21  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_22  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_23  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_24  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_25  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_26  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_27  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_28  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_29  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_30  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_31  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_32  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_33  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_34  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_34  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_35  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_36  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_37  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_38  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_39  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_40  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_41  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_42  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_43  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_44  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_45  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_46  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_47  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_48  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_49  LIKE VARIABLE    P0_BK_Master_Config_1
{
}

P0_BK_Master_Config_50  LIKE VARIABLE    P0_BK_Master_Config_1
{
}


ARRAY OF VARIABLE Master_Config
{
    LABEL   [menu_master_config];
    ELEMENTS
    {
        0,      P0_BK_Master_Config_1;
        1,      P0_BK_Master_Config_2;
        2,      P0_BK_Master_Config_3;
        3,      P0_BK_Master_Config_4;
        4,      P0_BK_Master_Config_5;
        5,      P0_BK_Master_Config_6;
        6,      P0_BK_Master_Config_7;
        7,      P0_BK_Master_Config_8;
        8,      P0_BK_Master_Config_9;
        9,      P0_BK_Master_Config_10;
        10,     P0_BK_Master_Config_11;
        11,     P0_BK_Master_Config_12;
        12,     P0_BK_Master_Config_13;
        13,     P0_BK_Master_Config_14;
        14,     P0_BK_Master_Config_15;
        15,     P0_BK_Master_Config_16;
        16,     P0_BK_Master_Config_17;
        17,     P0_BK_Master_Config_18;
        18,     P0_BK_Master_Config_19;
        19,     P0_BK_Master_Config_20;
        20,     P0_BK_Master_Config_21;
        21,     P0_BK_Master_Config_22;
        22,     P0_BK_Master_Config_23;
        23,     P0_BK_Master_Config_24;
        24,     P0_BK_Master_Config_25;
        25,     P0_BK_Master_Config_26;
        26,     P0_BK_Master_Config_27;
        27,     P0_BK_Master_Config_28;
        28,     P0_BK_Master_Config_29;
        29,     P0_BK_Master_Config_30;
        30,     P0_BK_Master_Config_31;
        31,     P0_BK_Master_Config_32;
        32,     P0_BK_Master_Config_33;
        33,     P0_BK_Master_Config_34;
        34,     P0_BK_Master_Config_35;
        35,     P0_BK_Master_Config_36;
        36,     P0_BK_Master_Config_37;
        37,     P0_BK_Master_Config_38;
        38,     P0_BK_Master_Config_39;
        39,     P0_BK_Master_Config_40;
        40,     P0_BK_Master_Config_41;
        41,     P0_BK_Master_Config_42;
        42,     P0_BK_Master_Config_43;
        43,     P0_BK_Master_Config_44;
        44,     P0_BK_Master_Config_45;
        45,     P0_BK_Master_Config_46;
        46,     P0_BK_Master_Config_47;
        47,     P0_BK_Master_Config_48;
        48,     P0_BK_Master_Config_49;
        49,     P0_BK_Master_Config_50;
    }
}


VARIABLE    Loc_Master_Config_1
{
    LABEL       "Byte 0..15";
    HELP        [BK_Master_Config_help];
    TYPE        ASCII(64);
    CLASS       LOCAL;
    PRE_EDIT_ACTIONS
    {
        method_scale_ConfigString(0, 0)
    }
    HANDLING    READ;
}

Loc_Master_Config_2     LIKE    VARIABLE    Loc_Master_Config_1
{
    REDEFINE    LABEL       "Byte 16..31";
    REDEFINE    PRE_EDIT_ACTIONS
    {
        method_scale_ConfigString(0, 1)
    }
}

Loc_Master_Config_3     LIKE    VARIABLE    Loc_Master_Config_1
{
    REDEFINE    LABEL       "Byte 32..47";
    REDEFINE    PRE_EDIT_ACTIONS
    {
        method_scale_ConfigString(0, 2)
    }
}

Loc_Master_Config_4     LIKE    VARIABLE    Loc_Master_Config_1
{
    REDEFINE    LABEL       "Byte 48..63";
    REDEFINE    PRE_EDIT_ACTIONS
    {
        method_scale_ConfigString(0, 3)
    }
}


ARRAY OF VARIABLE Loc_Master_Config
{
    LABEL   [menu_master_config];
    ELEMENTS
    {
        0, Loc_Master_Config_1;
        1, Loc_Master_Config_2;
        2, Loc_Master_Config_3;
        3, Loc_Master_Config_4;
    }
}


/*******************************************************************************/
/*****  SLAVE Configuration String  ********************************************/
/*******************************************************************************/

P0_BK_Slave_Config_Len  LIKE VARIABLE    P0_BK_Master_Config_Len
{
    REDEFINE    LABEL   [menu_slave_config];
}

P0_BK_Slave_Config_1    LIKE VARIABLE    P0_BK_Master_Config_1
{
    REDEFINE    LABEL   [menu_slave_config];
}

P0_BK_Slave_Config_2    LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_3    LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_4    LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_5    LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_6    LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_7    LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_8    LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_9    LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_10   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_11   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_12   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_13   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_14   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_15   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_16   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_17   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_18   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_19   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_20   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_21   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_22   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_23   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_24   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_25   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_26   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_27   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_28   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_29   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_30   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_31   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_32   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_33   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_34   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_34   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_35   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_36   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_37   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_38   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_39   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_40   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_41   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_42   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_43   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_44   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_45   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_46   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_47   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_48   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_49   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

P0_BK_Slave_Config_50   LIKE VARIABLE    P0_BK_Slave_Config_1
{
}

ARRAY OF VARIABLE Slave_Config
{
    LABEL   [menu_slave_config];
    ELEMENTS
    {
        0,      P0_BK_Slave_Config_1;
        1,      P0_BK_Slave_Config_2;
        2,      P0_BK_Slave_Config_3;
        3,      P0_BK_Slave_Config_4;
        4,      P0_BK_Slave_Config_5;
        5,      P0_BK_Slave_Config_6;
        6,      P0_BK_Slave_Config_7;
        7,      P0_BK_Slave_Config_8;
        8,      P0_BK_Slave_Config_9;
        9,      P0_BK_Slave_Config_10;
        10,     P0_BK_Slave_Config_11;
        11,     P0_BK_Slave_Config_12;
        12,     P0_BK_Slave_Config_13;
        13,     P0_BK_Slave_Config_14;
        14,     P0_BK_Slave_Config_15;
        15,     P0_BK_Slave_Config_16;
        16,     P0_BK_Slave_Config_17;
        17,     P0_BK_Slave_Config_18;
        18,     P0_BK_Slave_Config_19;
        19,     P0_BK_Slave_Config_20;
        20,     P0_BK_Slave_Config_21;
        21,     P0_BK_Slave_Config_22;
        22,     P0_BK_Slave_Config_23;
        23,     P0_BK_Slave_Config_24;
        24,     P0_BK_Slave_Config_25;
        25,     P0_BK_Slave_Config_26;
        26,     P0_BK_Slave_Config_27;
        27,     P0_BK_Slave_Config_28;
        28,     P0_BK_Slave_Config_29;
        29,     P0_BK_Slave_Config_30;
        30,     P0_BK_Slave_Config_31;
        31,     P0_BK_Slave_Config_32;
        32,     P0_BK_Slave_Config_33;
        33,     P0_BK_Slave_Config_34;
        34,     P0_BK_Slave_Config_35;
        35,     P0_BK_Slave_Config_36;
        36,     P0_BK_Slave_Config_37;
        37,     P0_BK_Slave_Config_38;
        38,     P0_BK_Slave_Config_39;
        39,     P0_BK_Slave_Config_40;
        40,     P0_BK_Slave_Config_41;
        41,     P0_BK_Slave_Config_42;
        42,     P0_BK_Slave_Config_43;
        43,     P0_BK_Slave_Config_44;
        44,     P0_BK_Slave_Config_45;
        45,     P0_BK_Slave_Config_46;
        46,     P0_BK_Slave_Config_47;
        47,     P0_BK_Slave_Config_48;
        48,     P0_BK_Slave_Config_49;
        49,     P0_BK_Slave_Config_50;
    }
}


Loc_Slave_Config_1      LIKE    VARIABLE    Loc_Master_Config_1
{
    REDEFINE    HELP        [BK_Slave_Config_help];
    REDEFINE    PRE_EDIT_ACTIONS
    {
        method_scale_ConfigString(1, 0)
    }
}

Loc_Slave_Config_2      LIKE    VARIABLE    Loc_Master_Config_2
{
    REDEFINE    HELP        [BK_Slave_Config_help];
    REDEFINE    PRE_EDIT_ACTIONS
    {
        method_scale_ConfigString(1, 1)
    }
}

Loc_Slave_Config_3      LIKE    VARIABLE    Loc_Master_Config_3
{
    REDEFINE    HELP        [BK_Slave_Config_help];
    REDEFINE    PRE_EDIT_ACTIONS
    {
        method_scale_ConfigString(1, 2)
    }
}

Loc_Slave_Config_4      LIKE    VARIABLE    Loc_Master_Config_4
{
    REDEFINE    HELP        [BK_Slave_Config_help];
    REDEFINE    PRE_EDIT_ACTIONS
    {
        method_scale_ConfigString(1, 3)
    }
}


ARRAY OF VARIABLE Loc_Slave_Config
{
    LABEL   [menu_slave_config];
    ELEMENTS
    {
        0, Loc_Slave_Config_1;
        1, Loc_Slave_Config_2;
        2, Loc_Slave_Config_3;
        3, Loc_Slave_Config_4;
    }
}


/*******************************************************************************/
/*****  METHODS  ***************************************************************/
/*******************************************************************************/

METHOD  method_scale_ConfigString(int ConfigType, int Part)
{
    DEFINITION
    {
        char    strConf[64];
        int     len;
        int     v[2];
        int     i;
        int     n;
        int     m;

        if (Part > 3)
        {
            _WARNING ("method_scale_ConfigString: invalid Parameter 'PART' = " + itoa(Part));
            process_abort();
        }
        else
            n = Part * 16;


        if (ConfigType == 0)
            len = P0_BK_Master_Config_Len;
        else
            len = P0_BK_Slave_Config_Len;

        i = 0;
        
        do
        {
            if (n >= len)
                break;

            if ((n % 16 != 0) && (n % 2 == 0))
            {
                strConf[i++] = '-';
                strConf[i++] = ' ';
            }
            if (ConfigType == 0)
            {
                v[0] = (Master_Config[n] & 0xF0) / 0x10;
                v[1] = (Master_Config[n] & 0x0F);
            }
            else
            {
                v[0] = (Slave_Config[n] & 0xF0) / 0x10;
                v[1] = (Slave_Config[n] & 0x0F);
            }
            for (m = 0; m < 2; m++)
            {
                if (v[m] < 0x0A)
                    strConf[i++] = v[m] + '0';
                else
                    strConf[i++] = 'A' + (v[m] - 0x0A);
            }
            strConf[i++] = ' ';
            n++;
        } while (n % 16 != 0);

        if (ConfigType == 0)
            Loc_Master_Config[Part] = strConf;
        else
            Loc_Slave_Config[Part]  = strConf;
    }
}


METHOD  method_check_config_string
{
    LABEL       [check_config_string];
    HELP        [check_config_string_help];
    DEFINITION
    {
        char    text[100];
        int     len;
        int     n;

        len = P0_BK_Master_Config_Len;
        
        if (len != ivar_value(P0_BK_Slave_Config_Len))
        {
            ACKNOWLEDGE ([info_config_length_error]);
            process_abort();
        }

        for (n = 0; n < len; n++)
        {
            if (ivar_value(Master_Config[n]) != ivar_value(Slave_Config[n]))
            {
                get_dictionary_string(info_config_mismatch, text);
                text = text + " (Byte " + itoa(n) + ").";
                ACKNOWLEDGE (text);
                process_abort();
                break;
            }
        }

        ACKNOWLEDGE ([info_config_ok]);
    }
}


/*******************************************************************************/
/*****  COMMANDS  **************************************************************/
/*******************************************************************************/

COMMAND read_MasterConfig
{
    SLOT        124;
    INDEX       0;
    OPERATION   READ;
    TRANSACTION
    {
        REQUEST
        {           
        }
        REPLY
        {
            P0_BK_Master_Config_Len,
            P0_BK_Master_Config_1,
            P0_BK_Master_Config_2,
            P0_BK_Master_Config_3,
            P0_BK_Master_Config_4,
            P0_BK_Master_Config_5,
            P0_BK_Master_Config_6,
            P0_BK_Master_Config_7,
            P0_BK_Master_Config_8,
            P0_BK_Master_Config_9,
            P0_BK_Master_Config_10,
            P0_BK_Master_Config_11,
            P0_BK_Master_Config_12,
            P0_BK_Master_Config_13,
            P0_BK_Master_Config_14,
            P0_BK_Master_Config_15,
            P0_BK_Master_Config_16,
            P0_BK_Master_Config_17,
            P0_BK_Master_Config_18,
            P0_BK_Master_Config_19,
            P0_BK_Master_Config_20,
            P0_BK_Master_Config_21,
            P0_BK_Master_Config_22,
            P0_BK_Master_Config_23,
            P0_BK_Master_Config_24,
            P0_BK_Master_Config_25,
            P0_BK_Master_Config_26,
            P0_BK_Master_Config_27,
            P0_BK_Master_Config_28,
            P0_BK_Master_Config_29,
            P0_BK_Master_Config_30,
            P0_BK_Master_Config_31,
            P0_BK_Master_Config_32,
            P0_BK_Master_Config_33,
            P0_BK_Master_Config_34,
            P0_BK_Master_Config_35,
            P0_BK_Master_Config_36,
            P0_BK_Master_Config_37,
            P0_BK_Master_Config_38,
            P0_BK_Master_Config_39,
            P0_BK_Master_Config_40,
            P0_BK_Master_Config_41,
            P0_BK_Master_Config_42,
            P0_BK_Master_Config_43,
            P0_BK_Master_Config_44,
            P0_BK_Master_Config_45,
            P0_BK_Master_Config_46,
            P0_BK_Master_Config_47,
            P0_BK_Master_Config_48,
            P0_BK_Master_Config_49,
            P0_BK_Master_Config_50
        }
    }
}

COMMAND read_SlaveConfig
{
    SLOT        123;
    INDEX       2;
    OPERATION   READ;
    TRANSACTION
    {
        REQUEST
        {           
        }
        REPLY
        {
            P0_BK_Slave_Config_Len,
            P0_BK_Slave_Config_1,
            P0_BK_Slave_Config_2,
            P0_BK_Slave_Config_3,
            P0_BK_Slave_Config_4,
            P0_BK_Slave_Config_5,
            P0_BK_Slave_Config_6,
            P0_BK_Slave_Config_7,
            P0_BK_Slave_Config_8,
            P0_BK_Slave_Config_9,
            P0_BK_Slave_Config_10,
            P0_BK_Slave_Config_11,
            P0_BK_Slave_Config_12,
            P0_BK_Slave_Config_13,
            P0_BK_Slave_Config_14,
            P0_BK_Slave_Config_15,
            P0_BK_Slave_Config_16,
            P0_BK_Slave_Config_17,
            P0_BK_Slave_Config_18,
            P0_BK_Slave_Config_19,
            P0_BK_Slave_Config_20,
            P0_BK_Slave_Config_21,
            P0_BK_Slave_Config_22,
            P0_BK_Slave_Config_23,
            P0_BK_Slave_Config_24,
            P0_BK_Slave_Config_25,
            P0_BK_Slave_Config_26,
            P0_BK_Slave_Config_27,
            P0_BK_Slave_Config_28,
            P0_BK_Slave_Config_29,
            P0_BK_Slave_Config_30,
            P0_BK_Slave_Config_31,
            P0_BK_Slave_Config_32,
            P0_BK_Slave_Config_33,
            P0_BK_Slave_Config_34,
            P0_BK_Slave_Config_35,
            P0_BK_Slave_Config_36,
            P0_BK_Slave_Config_37,
            P0_BK_Slave_Config_38,
            P0_BK_Slave_Config_39,
            P0_BK_Slave_Config_40,
            P0_BK_Slave_Config_41,
            P0_BK_Slave_Config_42,
            P0_BK_Slave_Config_43,
            P0_BK_Slave_Config_44,
            P0_BK_Slave_Config_45,
            P0_BK_Slave_Config_46,
            P0_BK_Slave_Config_47,
            P0_BK_Slave_Config_48,
            P0_BK_Slave_Config_49,
            P0_BK_Slave_Config_50
        }
    }
}